##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

$(eval $(call ADD2PACK,startscreen_z,src/assets/screens/startscreen.bin))
$(eval $(call PACKZX7B,startscreen_z,src/assets/screens/))
$(eval $(call ADD2PACK,finalscreen_z,src/assets/screens/finalscreen.bin))
$(eval $(call PACKZX7B,finalscreen_z,src/assets/screens/))

$(eval $(call ADD2PACK,pausescreen_z,src/assets/screens/pause.bin))
$(eval $(call PACKZX7B,pausescreen_z,src/assets/screens/))

$(eval $(call ADD2PACK,controlscreen_z,src/assets/screens/controls.bin))
$(eval $(call PACKZX7B,controlscreen_z,src/assets/screens/))


$(eval $(call ADD2PACK,packoceano0,src/assets/levels/oceano0.bin))
$(eval $(call ADD2PACK,packoceano0,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packoceano0,src/assets/levels/))

$(eval $(call ADD2PACK,packoceano1,src/assets/levels/oceano1.bin))
$(eval $(call ADD2PACK,packoceano1,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packoceano1,src/assets/levels/))

$(eval $(call ADD2PACK,packoceano2,src/assets/levels/oceano2.bin))
$(eval $(call ADD2PACK,packoceano2,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packoceano2,src/assets/levels/))

$(eval $(call ADD2PACK,packoceano3,src/assets/levels/oceano3.bin))
$(eval $(call ADD2PACK,packoceano3,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packoceano3,src/assets/levels/))

$(eval $(call ADD2PACK,packoceano4,src/assets/levels/oceano4.bin))
$(eval $(call ADD2PACK,packoceano4,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packoceano4,src/assets/levels/))

$(eval $(call ADD2PACK,packtierra0,src/assets/levels/tierra0.bin))
$(eval $(call ADD2PACK,packtierra0,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packtierra0,src/assets/levels/))

$(eval $(call ADD2PACK,packtierra1,src/assets/levels/tierra1.bin))
$(eval $(call ADD2PACK,packtierra1,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packtierra1,src/assets/levels/))

$(eval $(call ADD2PACK,packtierra2,src/assets/levels/tierra2.bin))
$(eval $(call ADD2PACK,packtierra2,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packtierra2,src/assets/levels/))

$(eval $(call ADD2PACK,packtierra3,src/assets/levels/tierra3.bin))
$(eval $(call ADD2PACK,packtierra3,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packtierra3,src/assets/levels/))

$(eval $(call ADD2PACK,packtierra4,src/assets/levels/tierra4.bin))
$(eval $(call ADD2PACK,packtierra4,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packtierra4,src/assets/levels/))

$(eval $(call ADD2PACK,packcielo0,src/assets/levels/cielo0.bin))
$(eval $(call ADD2PACK,packcielo0,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packcielo0,src/assets/levels/))


$(eval $(call ADD2PACK,packcielo1,src/assets/levels/cielo1.bin))
$(eval $(call ADD2PACK,packcielo1,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packcielo1,src/assets/levels/))

$(eval $(call ADD2PACK,packcielo2,src/assets/levels/cielo2.bin))
$(eval $(call ADD2PACK,packcielo2,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packcielo2,src/assets/levels/))

$(eval $(call ADD2PACK,packcielo3,src/assets/levels/cielo3.bin))
$(eval $(call ADD2PACK,packcielo3,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packcielo3,src/assets/levels/))

$(eval $(call ADD2PACK,packcielo4,src/assets/levels/cielo4.bin))
$(eval $(call ADD2PACK,packcielo4,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packcielo4,src/assets/levels/))

$(eval $(call ADD2PACK,packhell0,src/assets/levels/hell0.bin))
$(eval $(call ADD2PACK,packhell0,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packhell0,src/assets/levels/))

$(eval $(call ADD2PACK,packhell1,src/assets/levels/hell1.bin))
$(eval $(call ADD2PACK,packhell1,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packhell1,src/assets/levels/))


$(eval $(call ADD2PACK,packhell2,src/assets/levels/hell2.bin))
$(eval $(call ADD2PACK,packhell2,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packhell2,src/assets/levels/))

$(eval $(call ADD2PACK,packhell3,src/assets/levels/hell3.bin))
$(eval $(call ADD2PACK,packhell3,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packhell3,src/assets/levels/))

$(eval $(call ADD2PACK,packhell4,src/assets/levels/hell4.bin))
$(eval $(call ADD2PACK,packhell4,src/assets/levels/tiles.bin))

$(eval $(call PACKZX7B,packhell4,src/assets/levels/))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
