##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE= 0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites               ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, CONVERT         , img/enemigo.png , 8, 8, sp_enemigo, pal_main))
$(eval $(call IMG2SP, CONVERT         , img/jugador_animacion_arco.png , 8, 8, sp_jugador))
$(eval $(call IMG2SP, CONVERT         , img/flecha_animada.png , 4, 3, sp_bala))
$(eval $(call IMG2SP, CONVERT         , img/oceandoor.png , 10, 16, sp_oceandoor))
$(eval $(call IMG2SP, CONVERT         , img/grounddoor.png , 10, 16, sp_grounddoor))
$(eval $(call IMG2SP, CONVERT         , img/skydoor.png , 10, 16, sp_skydoor))
$(eval $(call IMG2SP, CONVERT         , img/helldoor.png , 10, 16, sp_helldoor))
$(eval $(call IMG2SP, CONVERT         , img/fantasma-animacion.png , 10, 10, sp_fantasma))
$(eval $(call IMG2SP, CONVERT         , img/tortuga.png , 10, 8, sp_tortuga))
$(eval $(call IMG2SP, CONVERT         , img/araña.png , 10, 8, sp_arana))
$(eval $(call IMG2SP, CONVERT         , img/llave.png , 4, 8, sp_llave))
$(eval $(call IMG2SP, CONVERT         , img/bola_fuego.png , 8, 8, sp_bolafuego))
$(eval $(call IMG2SP, CONVERT         , img/diablo.png , 16, 16, sp_diablo))
$(eval $(call IMG2SP, CONVERT         , img/pajaro.png , 8, 8, sp_pajaro))
$(eval $(call IMG2SP, CONVERT         , img/autobus.png , 16, 16, sp_autobus))
$(eval $(call IMG2SP, CONVERT         , img/llama_suelo.png , 24, 8, sp_llamasuelo))
$(eval $(call IMG2SP, CONVERT         , img/fuegosuelo4.png , 32, 8, sp_llamasuelo4))
$(eval $(call IMG2SP, CONVERT         , img/cabezavertical.png , 8, 8, sp_cabezalaser_v))
$(eval $(call IMG2SP, CONVERT         , img/laservertical.png , 8, 32, sp_laser_v))
$(eval $(call IMG2SP, CONVERT         , img/trampa.png , 16, 16, sp_trampa))
$(eval $(call IMG2SP, CONVERT         , img/trampa_pequeña.png , 8, 16, sp_trampa_pequena))
$(eval $(call IMG2SP, CONVERT         , img/espejo.png , 8, 12, sp_espejo))






$(eval $(call IMG2SP, SET_FOLDER      , src/assets/screens              ))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , img/startscreen.png , 160, 200, start_screen))
$(eval $(call IMG2SP, CONVERT         , img/finalscreen.png , 160, 200, final_screen))
$(eval $(call IMG2SP, CONVERT         , img/controls.png , 160, 200, controls_screen))
$(eval $(call IMG2SP, CONVERT         , img/pause.png , 160, 200, pause_screen))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/levels              ))

$(eval $(call IMG2SP, SET_IMG_FORMAT  , zgtiles            ))
$(eval $(call IMG2SP, CONVERT         , img/levels/tiles.png , 8, 8, tiles))



##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

#PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

##$(eval $(call IMG2SPRITES,img/tiles.png,0,g,8,8,$(PALETTE),zgtiles,src/assets/levels,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
