;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.module Main
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/man_game.h.s"
.include "man/man_menu.h.s"
.include "sys/render.h.s"
.include "man/man_levels.h.s"

.area _DATA
.area _CODE

_main::

inicio:
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm

   call man_menu_init
_menu_loop:
	call man_menu_update
	jr	 z, _menu_loop

   	call man_game_init

   

	call man_run_all_levels

_menu_loop2:
	call man_menu_update
	jr	 z, _menu_loop2

	jr    inicio



