;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "man_levels.h.s"
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "man/man_entity.h.s"
.include "man/man_game.h.s"
.include "man/man_menu.h.s"
.include "sys/physics.h.s"
.include "sys/ai_control.h.s"
.include "sys/render.h.s"
.include "sys/input.h.s"
.include "sys/collisions.h.s"
.include "assets/assets.h.s"
.include "cpct_functions.h.s"



jaffar: DefineCmp_Entity 70, 132, 1, 0, 4, 8, _sp_jugador_1, e_type_enemy, 0x0000, 0, collision_bala_player, e_alive, 0, 0, e_ai_standby, 0, 0, 0, 0
player: DefineCmp_Entity 4, 184, 1, 0, 4, 8, _sp_jugador_0, e_type_player, 0x0000, 0, collision_enemies, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0
puerta: DefineCmp_Entity 71, 176, 1, 2, 5, 16, _sp_oceandoor_1, e_type_fix, 0x0000, 0, collision_player, e_open, 0, 0, e_ai_noAI, 0, 0, 0, 0
bala: DefineCmp_Entity 0, 0, 1, 0, 2, 3, _sp_bala_0, e_type_bala, 0x0000, 0, collision_enemy, e_default, 0, 0, e_ai_noAI, 0, 0, 0, 0
enemigo: DefineCmp_Entity 38, 30, 0, 0, 4, 8, _sp_enemigo, e_type_enemy, 0x0000, 0, collision_bala_player, e_alive, 0, 0, e_ai_standby, 0, 0, 0, 0

fantasma: DefineCmp_Entity 6, 136, 0, 0, 5, 8, _sp_tortuga_1, e_type_enemy_ghost, 0x0000, 0,collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0

llave:	DefineCmp_Entity   24,150, 0, 0, 2, 8, _sp_llave	, e_type_key, 0x0000, 0, collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0
autobus: DefineCmp_Entity 6, 136, 0, 0, 8, 16, _sp_autobus, e_type_enemy_ghost, 0x0000, 0,collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0

trampa:	DefineCmp_Entity 6, 24, 0, 0, 8, 16, _sp_diablo, e_type_hidden, 0x0000, 0,collision_player, e_default, 0, 0, e_ai_noAI, 0, 0, 0, 0	
pobrediablo: DefineCmp_Entity 6, 24, 0, 0, 8, 16, _sp_diablo, e_type_enemy, 0x0000, 0,collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0
llamasuelo3: DefineCmp_Entity 30, 170, 0, 0, 12, 8, _sp_llamasuelo, e_type_enemy_ghost, 0x0000, 0,collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0
llamasuelo4:  DefineCmp_Entity 30, 170, 0, 0, 16, 8, _sp_llamasuelo4, e_type_enemy_ghost, 0x0000, 0,collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0
bolafuego:  DefineCmp_Entity 30, 170, 0, 0, 4, 8, _sp_bolafuego, e_type_enemy, 0x0000, 0,collision_player, e_alive, 0, 0, e_ai_standby, 0, 0, 0, 0


laser:	DefineCmp_Entity 6, 24, 0, 0, 4, 8, _sp_cabezalaser_v, e_type_laser, 0x0000, 0, collision_player, e_alive, 0, 0, e_ai_laser, 0, 0, 0, 0	


pinchos: DefineCmp_Entity 6, 24, 0, 0, 8, 16, _sp_trampa, e_type_enemy_ghost, 0x0000, 0, collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0
pinchospequeño: DefineCmp_Entity 6, 24, 0, 0, 4, 16, _sp_trampa_pequena, e_type_enemy_ghost, 0x0000, 0, collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0

espejo: DefineCmp_Entity 36, 132, 0, 0, 4, 12, _sp_espejo_0, e_type_espejo, 0x0000, 0, collision_player, e_alive, 0, 0, e_ai_noAI, 0, 0, 0, 0	


get_dir_nivel::
	ld hl, (_dir_nivel)
	ret

set_fin_game::
	ld a, #1
	ld (_fin_game), a
ret





activate_easter_egg::
	ld a,#1
	ld(_easter_egg_activo),a
	ret


man_abrir_puerta::
	call man_entity_getArray
loop_puerta:
	ld		a, e_etype(ix)
	xor		#e_type_fix
	jr 		z, abrir_puerta
	ld 		de,#tam_e
	add 	ix,de
	jr 		loop_puerta
abrir_puerta:
	ld 		e_state(ix), #e_open
	ld 		a,(_mundo)
	cp 		#1
	jr      nz, estierra
	ld		hl, #_sp_oceandoor_1
	jr  	finpuerta

estierra:

	cp 		#2
	jr      nz, escielo
	ld		hl, #_sp_grounddoor_1
	jr  	finpuerta



escielo:
	cp 		#3
	jr      nz, esinfierno
	ld		hl, #_sp_skydoor_1
	jr  	finpuerta


esinfierno:	
	ld 		hl, #_sp_helldoor_1


finpuerta:
	ld 		e_sprite_l(ix), l
	ld 		e_sprite_h(ix), h
	
	ret

man_cerrar_puerta::
call man_entity_getArray
loop_puerta2:
	ld		a, e_etype(ix)
	xor		#e_type_fix
	jr 		z, cerrar_puerta
	ld 		bc,#tam_e
	add 	ix,bc
	jr 		loop_puerta2
cerrar_puerta:
	ld e_state(ix), #e_close
	ld 		a,(_mundo)
	cp 		#1
	jr      nz, estierraclose
	ld		hl, #_sp_oceandoor_0
	jr  	finpuertaclose

estierraclose:

	cp 		#2
	jr      nz, escieloclose
	ld		hl, #_sp_grounddoor_0
	jr  	finpuertaclose



escieloclose:
	cp 		#3
	jr      nz, esinfiernoclose
	ld		hl, #_sp_skydoor_0
	jr  	finpuertaclose

esinfiernoclose:

	ld 		hl, #_sp_helldoor_0


finpuertaclose:
	ld 		e_sprite_l(ix), l
	ld 		e_sprite_h(ix), h
	
	ret


man_all_levels_init::
	call sys_eren_clear
	call man_entity_init

	call sys_eren_init
	call sys_ai_control_init
	call sys_physics_init
	call sys_input_init
ret


repetidor::

		loop:
			call man_game_update
			ld 	 a, (_fin_game)
			dec  a
			jr 	 z, acabarnivel
			call get_puerta
			dec a
			jr 	z,acabarnivel

			call man_entity_getArray
			ld 	 a,e_state(ix)
			dec  a
			jr   z, muere

			call cpct_waitVSYNC_asm
			call man_game_render
			jr 	 loop

		muere:
			call cpct_waitVSYNC_asm
			call man_game_render
			;;call sys_input_setEnemigosEstaticos
			xor  a
			ret

		acabarnivel:
			ld   a,#1
			ret


man_ee_init:: 

	ld a,#1
	ld (_mundo), a

	call man_all_levels_init
	ld 	hl, #_packoceano0_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	
	ld ix, #puerta
	ld e_x(ix),#71
	ld e_y(ix),#176

	ld hl,#puerta
	call man_entity_create

	ld hl,#jaffar
	call man_entity_create

ret



man_oceano0_init::

	ld a,#1
	ld (_mundo), a

	call man_all_levels_init
	ld hl, #_packoceano0_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	
	ld ix, #puerta
	ld e_x(ix),#71
	ld e_y(ix),#176
	ld hl, #_sp_oceandoor_1
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h

	ld hl,#puerta
	call man_entity_create

	ld ix, #espejo
	ld e_x(ix),#2
	ld e_y(ix),#100
	ld hl, #espejo
	call man_entity_create

	ret

man_oceano1_init::

	call man_all_levels_init
	ld hl, #_packoceano1_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap


	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#71
	ld e_y(ix),#176
	ld hl, #_sp_oceandoor_1
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#puerta
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#38
	ld e_y(ix),#32
	ld  hl, #_sp_enemigo
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create
	ret


man_oceano2_init::

	call man_all_levels_init
	ld hl, #_packoceano2_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld 	ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#4
	ld e_y(ix),#32
	ld hl, #_sp_oceandoor_1
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#puerta
	call man_entity_create


	ld ix, #enemigo
	ld e_x(ix),#59
	ld e_y(ix),#40
	ld hl, #enemigo
	ld e_ai_status(ix), #e_ai_noAI
	call man_entity_create


	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#182
	ld  hl, #_sp_enemigo
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	ld e_ai_status(ix), #e_ai_standby
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#6
	ld e_y(ix),#136
	ld  hl, #_sp_tortuga_1
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ret

man_oceano3_init::

	call man_all_levels_init
	ld hl, #_packoceano3_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap


	ld ix, #player
	ld e_x(ix),#16
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create


	ld ix, #puerta
	ld e_x(ix),#4
	ld e_y(ix),#168
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta
	

	ld ix, #llave
	ld e_x(ix),#24
	ld e_y(ix),#150
	ld hl, #llave
	call man_entity_create


	ld ix, #enemigo
	ld e_x(ix),#12
	ld e_y(ix),#48
	ld hl, #enemigo
	ld e_ai_status(ix), #e_ai_standby
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld e_ai_status(ix),#e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ret

man_oceano4_init::
	call man_all_levels_init
	ld hl, #_packoceano4_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#48
	ld e_y(ix),#16
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix ,#laser
	ld e_x(ix), #32
	ld e_y(ix), #24
	ld 	e_sy(ix), #8
	ld  hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld hl, #laser
	call man_entity_create


	ld ix ,#laser
	ld e_x(ix), #56
	ld e_y(ix), #56
	ld e_sy(ix), #8
	ld e_aim_x(ix),#100
	ld hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld hl, #laser
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#4
	ld e_y(ix),#86
	ld e_sx(ix), #5
	ld e_sy(ix), #10
	ld hl, #_sp_fantasma_1
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	;;ld ix ,#laser
	;;ld e_x(ix), #44
	;;ld e_y(ix), #88
	;;ld 	e_sy(ix), #8
	;;ld e_aim_x(ix),#50
	;;ld  hl,#_sp_cabezalaser_v
	;;ld e_sprite_l(ix),l
	;;ld e_sprite_h(ix),h
	;;ld e_etype(ix),#e_type_laser
	;;ld hl, #laser
	;;call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#48
	ld e_y(ix),#112
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix ,#laser
	ld e_x(ix), #48
	ld e_y(ix), #120
	ld 	e_sy(ix), #8
	ld e_aim_x(ix),#150
	ld  hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld hl, #laser
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#11
	ld e_y(ix),#150
	ld hl, #_sp_fantasma_0
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#11
	ld e_y(ix),#176
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #llave
	ld e_x(ix),#24
	ld e_y(ix),#180
	ld hl, #llave
	call man_entity_create

	ret

man_tierra0_init::
	ld a,#2
	ld (_mundo),a

	call man_all_levels_init
	ld hl, #_packtierra0_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#68
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#68
	ld e_y(ix),#160
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #llave
	ld e_x(ix),#4
	ld e_y(ix),#16
	ld hl, #llave
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#4
	ld e_y(ix),#88
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#44
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#52
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create

	ld ix, #pinchospequeño
	ld e_x(ix),#60
	ld e_y(ix),#176
	ld hl, #pinchospequeño
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#28
	ld e_y(ix),#118
	ld e_sx(ix), #5
	ld e_sy(ix), #10
	ld hl, #_sp_fantasma_0
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#58
	ld e_y(ix),#70
	ld e_sx(ix), #5
	ld e_sy(ix), #10
	ld hl, #_sp_fantasma_0
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create


	ret

man_tierra1_init::
	call man_all_levels_init
	ld hl, #_packtierra1_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#4
	ld e_y(ix),#40
	ld hl, #llave
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#71
	ld e_y(ix),#8
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #enemigo
	ld e_x(ix),#12
	ld e_y(ix),#58
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#60
	ld e_y(ix),#80
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#36
	ld e_y(ix),#58
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#16
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#28
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#40
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create

	ld ix, #pinchos
	ld e_x(ix),#52
	ld e_y(ix),#176
	ld hl, #pinchos
	call man_entity_create
	ret

man_tierra2_init::
	call man_all_levels_init
	ld hl, #_packtierra2_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#12
	ld e_y(ix),#104
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#74
	ld e_y(ix),#184
	ld hl, #llave
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#37
	ld e_y(ix),#8
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #enemigo
	ld e_x(ix),#24
	ld e_y(ix),#56
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#60
	ld e_y(ix),#56
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#80
	ld e_ai_status(ix),#e_ai_standby
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#152
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create


	ld ix, #pinchos
	ld e_x(ix),#64
	ld e_y(ix),#104
	ld hl, #pinchos
	call man_entity_create

	ld ix, #pinchospequeño
	ld e_x(ix),#72
	ld e_y(ix),#104
	ld hl, #pinchospequeño
	call man_entity_create

	ret

man_tierra3_init::
	call man_all_levels_init
	ld hl, #_packtierra3_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#72
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix ,#laser
	ld e_x(ix), #72
	ld e_y(ix), #0
	ld 	e_sy(ix), #8
	ld e_aim_x(ix),#0
	ld  hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld hl, #laser
	call man_entity_create
	
	ld ix, #enemigo
	ld e_x(ix),#44
	ld e_y(ix),#16
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix ,#laser
	ld e_x(ix), #16
	ld e_y(ix), #24
	ld 	e_sy(ix), #8
	ld e_aim_x(ix),#0
	ld  hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld hl, #laser
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#44
	ld e_y(ix),#64
	ld e_ai_status(ix),#e_ai_noAI
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#71
	ld e_y(ix),#64
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix ,#laser
	ld e_x(ix), #48
	ld e_y(ix), #104
	ld 	e_sy(ix), #8
	ld e_aim_x(ix),#255
	ld  hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld hl, #laser
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#44
	ld e_y(ix),#160
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#72
	ld e_y(ix),#160
	ld hl, #llave
	call man_entity_create

	

	ret

man_tierra4_init::
	call man_all_levels_init
	ld hl, #_packtierra4_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap


	ld a,#2
	ld (_mundo),a

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#72
	ld e_y(ix),#24
	ld hl, #llave
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#44
	ld e_y(ix),#40
	ld e_ai_status(ix),#e_ai_standby
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#4
	ld e_y(ix),#48
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#36
	ld e_y(ix),#176
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta
	
	ld ix, #enemigo
	ld e_x(ix),#48
	ld e_y(ix),#184
	ld  hl, #_sp_arana
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create


	ret


man_cielo0_init::
	ld a,#3
	ld (_mundo),a
	call man_all_levels_init
	ld hl, #_packcielo0_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#4
	ld e_y(ix),#8
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #enemigo
	ld e_x(ix),#44
	ld e_y(ix),#16
	ld e_ai_status(ix),#e_ai_standby
	ld  hl, #_sp_pajaro
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#30
	ld e_y(ix),#120
	ld  hl, #_sp_pajaro
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#72
	ld e_y(ix),#160
	ld  hl, #_sp_pajaro
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #enemigo
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#72
	ld e_y(ix),#184
	ld hl, #llave
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#44
	ld e_y(ix),#78
	ld e_sx(ix), #5
	ld e_sy(ix), #10
	ld hl, #_sp_fantasma_0
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#56
	ld e_y(ix),#40
	ld e_sx(ix), #8
	ld e_sy(ix), #16
	ld hl, #_sp_autobus
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#7
	ld e_y(ix),#176
	ld e_sx(ix), #8
	ld e_sy(ix), #16
	ld hl, #_sp_autobus
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ret


man_cielo1_init::
	call man_all_levels_init
	ld hl, #_packcielo1_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#37
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#70
	ld e_y(ix),#146
	ld hl, #llave
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#71
	ld e_y(ix),#16
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #enemigo
	ld e_x(ix),#28
	ld e_y(ix),#80
	ld e_vy(ix), #1
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#43
	ld e_y(ix),#80
	ld e_vy(ix), #1
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#60
	ld e_y(ix),#80
	ld e_vy(ix), #1
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#70
	ld e_y(ix),#138
	ld e_vy(ix), #0
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#68
	ld e_y(ix),#146
	ld e_vy(ix), #0
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#72
	ld e_y(ix),#146
	ld e_vy(ix), #0
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#70
	ld e_y(ix),#152
	ld e_vy(ix), #0
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#8
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#22
	ld e_y(ix),#176
	ld e_sx(ix), #8
	ld e_sy(ix), #16
	ld hl, #_sp_autobus
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#38
	ld e_y(ix),#176
	ld e_sx(ix), #8
	ld e_sy(ix), #16
	ld hl, #_sp_autobus
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create

	ld ix, #trampa
	ld e_x(ix),#54
	ld e_y(ix),#176
	ld e_sx(ix), #8
	ld e_sy(ix), #16
	ld hl, #_sp_autobus
	ld e_sprite_l(ix), l
	ld e_sprite_h(ix), h
	ld hl,#trampa
	call man_entity_create


	ret

man_cielo2_init::
	call man_all_levels_init
	ld hl, #_packcielo2_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#12
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#4
	ld e_y(ix),#24
	ld hl, #llave
	call man_entity_create


	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#32
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#64
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#70
	ld e_y(ix),#64
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#96
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#4
	ld e_y(ix),#96
	ld  hl, #_sp_fantasma_1
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#128
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create


	ld ix, #fantasma
	ld e_x(ix),#70
	ld e_y(ix),#128
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create


	ld ix, #enemigo
	ld e_x(ix),#40
	ld e_y(ix),#160
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create


	ld ix, #fantasma
	ld e_x(ix),#4
	ld e_y(ix),#160
	ld  hl, #_sp_fantasma_1
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create


	ld ix, #puerta
	ld e_x(ix),#70
	ld e_y(ix),#170
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #fantasma
	ld e_x(ix),#70
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create


	ret

man_cielo3_init::
	call man_all_levels_init
	ld hl, #_packcielo3_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#11
	ld e_y(ix),#184
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#20
	ld e_y(ix),#48
	ld hl, #llave
	call man_entity_create


	ld ix, #enemigo
	ld e_x(ix),#28
	ld e_y(ix),#24
	ld e_ai_status(ix), #e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#20
	ld e_y(ix),#48
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#56
	ld e_y(ix),#80
	ld e_ai_status(ix), #e_ai_noAI
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#64
	ld e_y(ix),#104
	ld e_ai_status(ix), #e_ai_standby
	ld hl, #enemigo
	call man_entity_create

	ld ix, #enemigo
	ld e_x(ix),#20
	ld e_y(ix),#120
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create


	ld ix, #fantasma
	ld e_x(ix),#4
	ld e_y(ix),#40
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create


	ld ix, #puerta
	ld e_x(ix),#55
	ld e_y(ix),#72
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta


	ret


man_cielo4_init::
	call man_all_levels_init
	ld hl, #_packcielo4_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix),#4
	ld e_y(ix),#12
	ld hl,#player
	call man_entity_create

	ld hl, #bala
	call man_entity_create

	ld ix, #llave
	ld e_x(ix),#74
	ld e_y(ix),#14
	ld hl, #llave
	call man_entity_create

	ld ix, #puerta
	ld e_x(ix),#4
	ld e_y(ix),#176
	ld hl,#puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #enemigo
	ld e_x(ix),#38
	ld e_y(ix),#48
	ld e_ai_status(ix),#e_ai_standby
	ld hl, #enemigo
	call man_entity_create


	ld ix, #fantasma
	ld e_x(ix),#20
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#30
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#40
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#50
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#60
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create

	ld ix, #fantasma
	ld e_x(ix),#70
	ld e_y(ix),#184
	ld  hl, #_sp_fantasma_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld hl, #fantasma
	call man_entity_create


	ret


man_hell0_init::
	
	ld a,#4
	ld (_mundo), a
	call man_all_levels_init
	ld hl, #_packhell0_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix), #4
	ld e_y(ix), #184
	ld 	hl, #player
	call man_entity_create

	ld hl, #bala
	call man_entity_create


	ld ix, #puerta 
	ld e_x(ix), #70
	ld e_y(ix), #176
	ld hl, #puerta
	call man_entity_create
	call man_cerrar_puerta


	ld ix, #llave
	ld e_x(ix), #6
	ld e_y(ix), #24
	ld hl, #llave
	call man_entity_create

	ld ix, #pobrediablo
	ld e_x(ix), #6
	ld e_y(ix), #24
	ld hl, #pobrediablo
	call man_entity_create

	ld ix, #pobrediablo
	ld e_x(ix), #68
	ld e_y(ix), #56
	ld hl, #pobrediablo
	call man_entity_create


	
	ld ix, #llamasuelo4
	ld e_x(ix),#24
	ld e_y(ix),#184
	ld hl, #llamasuelo4
	call man_entity_create

	ld ix, #llamasuelo4
	ld e_x(ix),#40
	ld e_y(ix),#184
	ld hl, #llamasuelo4
	call man_entity_create



	ret




man_hell1_init::
	call man_all_levels_init
	ld hl, #_packhell1_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld  ix, #player
	ld  e_x(ix), #6
	ld  e_y(ix), #16
	ld 	hl, #player
	call man_entity_create

	ld hl, #bala
	call man_entity_create


	ld  ix, #puerta
	ld  e_x(ix), #6
	ld  e_y(ix), #136
	ld hl, #puerta
	call man_entity_create
	call man_cerrar_puerta


	ld ix, #llave
	ld e_x(ix), #32
	ld e_y(ix), #8
	ld hl, #llave
	call man_entity_create

	ld ix, #bolafuego
	ld e_x(ix),#60
	ld e_y(ix),#40
	ld hl, #bolafuego
	call man_entity_create



	ld ix, #llamasuelo3
	ld e_x(ix),#4
	ld e_y(ix),#104
	ld hl, #llamasuelo3
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#16
	ld e_y(ix),#104
	ld hl, #llamasuelo3
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#36
	ld e_y(ix),#104
	ld hl, #llamasuelo3
	call man_entity_create



	ld ix, #llamasuelo3
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create


	ld ix, #llamasuelo3
	ld e_x(ix),#16
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#32
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#48
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create



	

	ret



man_hell2_init::

call man_all_levels_init
	ld hl, #_packhell2_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix), #60
	ld e_y(ix), #184
	ld 	hl, #player
	call man_entity_create

	ld hl, #bala
	call man_entity_create


	ld ix, #bolafuego
	ld e_x(ix),#60
	ld e_y(ix),#48
	ld hl, #bolafuego
	call man_entity_create

	ld ix, #pobrediablo
	ld e_x(ix),#4
	ld e_y(ix),#120
	ld hl, #pobrediablo
	call man_entity_create

	ld ix, #puerta 
	ld e_x(ix), #4
	ld e_y(ix), #120
	ld hl, #puerta
	call man_entity_create
	call man_cerrar_puerta


	ld ix, #llave
	ld e_x(ix), #20
	ld e_y(ix), #148
	ld hl, #llave
	call man_entity_create


	


	ld ix, #llamasuelo4
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl, #llamasuelo4
	call man_entity_create


	ld ix, #llamasuelo3
	ld e_x(ix),#24
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#36
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create
	ret



man_hell3_init::

	call man_all_levels_init
	ld hl, #_packhell3_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix), #38
	ld e_y(ix), #150
	ld 	hl, #player
	call man_entity_create

	ld hl, #bala
	call man_entity_create


	call cpct_getRandom_lcg_u8_asm

	bit 1,a
	ld ix, #puerta 
	jr z,puertaizqhell3

	ld e_x(ix), #70
	jr conthell3


 puertaizqhell3:
	
	ld e_x(ix), #4

 conthell3:
	ld e_y(ix), #16
	ld hl, #puerta
	call man_entity_create
	call man_cerrar_puerta

	ld ix, #pobrediablo
	ld e_x(ix),#4
	ld e_y(ix),#16
	ld hl, #pobrediablo
	call man_entity_create

	ld ix, #pobrediablo
	ld e_x(ix),#68
	ld e_y(ix),#16
	ld hl, #pobrediablo
	call man_entity_create

	call cpct_getRandom_lcg_u8_asm

	bit 1,a
	ld ix, #llave
	jr z, llaveizqhell3
	ld e_x(ix), #70
	jr contllavehell3
 llaveizqhell3:
 	ld e_x(ix), #6
 contllavehell3:
	
	ld e_y(ix), #164
	ld hl, #llave
	call man_entity_create



	ld ix, #llamasuelo4
	ld e_x(ix),#4
	ld e_y(ix),#184
	ld hl, #llamasuelo4
	call man_entity_create

	ld ix, #llamasuelo4
	ld e_x(ix),#20
	ld e_y(ix),#184
	ld hl, #llamasuelo4
	call man_entity_create

	ld ix, #llamasuelo4
	ld e_x(ix),#36
	ld e_y(ix),#184
	ld hl, #llamasuelo4
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#52
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create

	ld ix, #llamasuelo3
	ld e_x(ix),#64
	ld e_y(ix),#184
	ld hl, #llamasuelo3
	call man_entity_create

	ret
	
man_hell4_init::

	call man_all_levels_init
	ld hl, #_packhell4_end
	ld (_dir_nivel), hl
	call sys_eren_tilemap

	ld ix, #player
	ld e_x(ix), #4
	ld e_y(ix), #184
	ld 	hl, #player
	call man_entity_create

	ld hl, #bala
	call man_entity_create


	ld ix, #puerta 
	ld e_x(ix), #71
	ld e_y(ix), #16
	ld hl, #puerta
	call man_entity_create
	call man_cerrar_puerta


	ld ix, #llave
	ld e_x(ix), #6
	ld e_y(ix), #24
	ld hl, #llave
	call man_entity_create
	ret
	

man_ee_run::
ee:
	call man_ee_init

	call repetidor
	dec  a
	jr 	 nz,ee

	ret


man_oceano0_run::
oceano:
	call man_oceano0_init

	call repetidor
	dec  a
	jr 	 nz,oceano

	ret


man_oceano1_run::
oceano1:
	call man_oceano1_init

	call repetidor
	dec  a
	jr 	 nz,oceano1

	ret


man_oceano2_run::
oceano2:
	call man_oceano2_init

	call repetidor
	dec  a
	jr 	 nz,oceano2

	ret

man_oceano3_run::
oceano3:
	call man_oceano3_init

	call repetidor
	dec  a
	jr 	 nz,oceano3

	ret

man_oceano4_run::
oceano4:
	call man_oceano4_init

	call repetidor
	dec  a
	jr 	 nz,oceano4

	ret

man_tierra0_run::
tierra:
	call man_tierra0_init

	call repetidor
	dec  a
	jr 	 nz,tierra

	ret

man_tierra1_run::
tierra1:
	call man_tierra1_init

	call repetidor
	dec  a
	jr 	 nz,tierra1

	ret

man_tierra2_run::
tierra2:
	call man_tierra2_init

	call repetidor
	dec  a
	jr 	 nz,tierra2

	ret

man_tierra3_run::
tierra3:
	call man_tierra3_init

	call repetidor
	dec  a
	jr 	 nz,tierra3

	ret

man_tierra4_run::
tierra4:
	call man_tierra4_init

	call repetidor
	dec  a
	jr 	 nz,tierra4

	ret

man_cielo0_run::
cielo:
	call man_cielo0_init

	call repetidor
	dec  a
	jr 	 nz,cielo

	ret

man_cielo1_run::
cielo1:
	call man_cielo1_init

	call repetidor
	dec  a
	jr 	 nz,cielo1

	ret

man_cielo2_run::
cielo2:
	call man_cielo2_init

	call repetidor
	dec  a
	jr 	 nz,cielo2

	ret

man_cielo3_run::
cielo3:
	call man_cielo3_init

	call repetidor
	dec  a
	jr 	 nz,cielo3

	ret

man_cielo4_run::
cielo4:
	call man_cielo4_init

	call repetidor
	dec  a
	jr 	 nz,cielo4

	ret



man_hell0_run::
hell0:
	call man_hell0_init

	call repetidor
	dec  a
	jr 	 nz,hell0

	ret


man_hell1_run::
hell1:
	call man_hell1_init

	call repetidor
	dec  a
	jr 	 nz,hell1

	ret


man_hell2_run::
hell2:
	call man_hell2_init

	call repetidor
	dec  a
	jr 	 nz,hell2

	ret

man_hell3_run::
hell3:
	call man_hell3_init

	call repetidor
	dec  a
	jr 	 nz,hell3

	ret

man_hell4_run::
hell4:
	call man_hell4_init

	call repetidor
	dec  a
	jr 	 nz,hell4

	ret

man_run_all_levels::

	
	ld  a, #0
	ld  (_fin_game), a
	ld  (_easter_egg_activo),a
	call man_oceano0_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_oceano1_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_oceano2_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_oceano3_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_oceano4_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_tierra0_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_tierra1_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_tierra2_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_tierra3_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_tierra4_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_cielo0_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_cielo1_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_cielo2_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_cielo3_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_cielo4_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	ld a, (_easter_egg_activo)
	dec a
	jp nz, saltaree
	call man_ee_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
saltaree:
	call man_hell0_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_hell1_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_hell2_run
	ld 	a, (_fin_game)
	dec a
	jr  z, findeljuego
	call man_hell3_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	call man_hell4_run
	ld 	a, (_fin_game)
	dec a
	jp  z, findeljuego
	

findeljuego:
	call man_menu_final
ret


