;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "cpct_functions.h.s"
.include "man/man_menu.h.s"
.include "sys/render.h.s"
.include "cpctelera.h.s"
.include "assets/assets.h.s"
.include "assets/screens/startscreen_z.h.s"
.include "assets/screens/finalscreen_z.h.s"
.include "assets/screens/controlscreen_z.h.s"
.include "assets/screens/pausescreen_z.h.s"
.include "man/man_levels.h.s"

man_menu_init::
	call	sys_eren_init

	ld 	hl,#_startscreen_z_end
	ld 	de,#0xFFFF
	call cpct_zx7b_decrunch_s_asm

	ret

man_menu_update::
	call cpct_scanKeyboard_f_asm
	ld 	hl, #Key_Return
	call cpct_isKeyPressed_asm

	ret


man_menu_controls::
	ld 	hl,#_controlscreen_z_end
	ld 	de,#0xFFFF
	call cpct_zx7b_decrunch_s_asm
_loopcontrols:

	call cpct_scanKeyboard_f_asm
	ld 	hl, #Key_Esc
	call cpct_isKeyPressed_asm
	jr	z, _loopcontrols
	ret

man_menu_final::
	
	ld 	hl,#_finalscreen_z_end
	ld 	de,#0xFFFF
	call cpct_zx7b_decrunch_s_asm
	ret


man_menu_pause::
	ld 	hl,#_pausescreen_z_end
	ld 	de,#0xFFFF
	call cpct_zx7b_decrunch_s_asm

_loopPause:
	call cpct_scanKeyboard_f_asm
	ld 	hl, #Key_C
	call cpct_isKeyPressed_asm
	jr 	z,C_NotPressed
	call man_menu_controls
	ld 	hl,#_pausescreen_z_end
	ld 	de,#0xFFFF
	call cpct_zx7b_decrunch_s_asm

C_NotPressed:
	call cpct_scanKeyboard_f_asm
	ld 	hl, #Key_R
	call cpct_isKeyPressed_asm
	jr 	z,R_NotPressed
	;;CODIGO PARA REINICIAR EL JUEGO
	call set_fin_game
	ret 
R_NotPressed:
	call cpct_scanKeyboard_f_asm
	ld 	hl, #Key_Esc
	call cpct_isKeyPressed_asm
	jr nz, finPause
	jr _loopPause

finPause:
	call get_dir_nivel
	call sys_eren_tilemap

	ret
