;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "ai_control.h.s"
.include "cmp/entity.h.s"
.include "man/man_entity.h.s"
.include "cpctelera.h.s"
.include "assets/assets.h.s"


distanciaPlayer = 50

sys_ai_standby::

	ld a, e_x(iy)
	sub e_x(ix)
	jr	nc, noNegarX
	neg
noNegarX:

	ld c, a
	ld a, e_y(iy)
	sub e_y(ix)
	jr 	nc, noNegarY
	neg
noNegarY:

	add c
	sub #distanciaPlayer
	jr c, cambiarEstado
	ret

cambiarEstado:
	ld e_ai_status(ix), #e_ai_moveto
	ret


sys_ai_moveto::
	ld a, e_x(iy)
	ld e_aim_x(ix), a
	ld a, e_y(iy)
	ld e_aim_y(ix), a

	ld	a, e_aim_x(ix)
	sub e_x(ix)
	jr	nc, may_eq_aimx

men_aimx:
	ld 	e_vxdec(ix), #-64
	jr	_endx
may_eq_aimx:
	jr	z, he_llegado
	ld 	e_vxdec(ix), #64
	jr	_endx
he_llegado:
	ld 	e_vx(ix), #0
	ld  e_vxdec(ix), #0
_endx:

	ld	a, e_aim_y(ix)
	sub e_y(ix)
	jr	nc, may_eq_aimy

men_aimy:
	ld 	e_vydec(ix), #-127
	jr	_endy
may_eq_aimy:
	jr	z, he_llegado_y
	ld 	e_vydec(ix), #127
	jr	_endy
he_llegado_y:
	ld 	e_vy(ix), #0
	ld  e_vydec(ix), #0
	ld 	a, e_vx(ix)
	or  a
	jr	nz, _endy
	ld 	e_ai_status(ix), #e_ai_standby
_endy:
	ret




sys_ai_laser::
	ld a, e_aim_x(ix) ;;No es x, es un contador
	add #5
	ld e_aim_x(ix),a
	jr nc, endlaser
	ld a, e_etype(ix)
	cp #e_type_enemy_ghost

	jr z, turn_off_laser
	ld 	e_sy(ix), #32
	ld  hl,#_sp_laser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_enemy_ghost
	jr endlaser

turn_off_laser:
	;;ld 	e_sy(ix), #8
	;;ld  hl,#_sp_cabezalaser_v
	;;ld e_sprite_l(ix),l
	;;ld e_sprite_h(ix),h
	;;ld e_etype(ix),#e_type_laser
	ld e_state(ix), #e_turnoff_laser




endlaser:
ret


sys_ai_control_init::
ret

sys_ai_control_update::

ld 		b, a
call 	man_entity_getArrayInicio_IY

_loop:								;; RECORREMOS TODAS LAS ENTIDADES

	ld	a, e_ai_status(ix)
	cp  #e_ai_noAI
	jr  z, no_AI
AI_ent:
	cp  #e_ai_standby
	call z, sys_ai_standby
	ld	a, e_ai_status(ix)
	cp 	#e_ai_moveto
	call z, sys_ai_moveto
	ld	a, e_ai_status(ix)
	cp  #e_ai_laser
	call z, sys_ai_laser

no_AI:

	dec b
	ret z

	ld 		de,#tam_e
	add 	ix,de
	jr 		_loop

ret