;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "sys/collisions.h.s"
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "man/man_entity.h.s"
.include "cmp/array_structure.h.s"
.include "man/man_menu.h.s"
.include "man/man_levels.h.s"
.include "assets/assets.h.s"

tocarpuerta = 0

get_puerta::
ld 		a,(tocarpuerta)
ret



sys_collisions_entities::
	
	ld 		a, e_collisionable(ix)
	xor 	#collision_enemies
	jr 		nz,comprobacion2
	call comprueba_collision_player_enemies
	jr 		fin

comprobacion2:

	ld 		a, e_collisionable(ix)
	xor 	#collision_enemy
	jr 		nz,fin
	call comprueba_collision_bala_enemy
	jr 		fin

fin:
	ret

;;------------------------------------------------------------------------------------------------------------------------------

sys_collisions_update::
	
	ld 		b,a
	xor		a
	ld 		(tocarpuerta),a
_loop:
	push bc
	call sys_collisions_entities
	pop bc
	dec b
	ret z

	ld 		de,#tam_e
	add 	ix,de
	jr 		_loop

	ret

;;------------------------------------------------------------------------------------------------------------------------------

comprueba_collision_player_enemies::
	
	call man_entity_getArray_IY

loop2:

	ld 	a,e_etype(iy)
	xor #e_type_enemy
	jr 	nz, esfantasma

	ld	a, e_state(iy)
	xor	#e_alive
	jr	z, colision

esfantasma:	

	ld 	a,e_etype(iy)
	xor #e_type_enemy_ghost
	jr 	nz,comprobarLlave

	ld	a, e_state(iy)
	xor	#e_alive
	jr	z, colision

comprobarLlave:
	ld 	a,e_etype(iy)
	xor #e_type_key
	jr 	nz,comprobarPuerta
	ld 	a,e_state(iy)
	xor #e_alive
	jr  z, colision


comprobarPuerta:
	ld 	a,e_etype(iy)
	xor #e_type_fix
	jr 	z, finNivel
	jr	seguir
colision:
	
	call comprobar_colision
	dec d
	jr 	nz,seguir
	ld  a,e_etype(iy)
	xor #e_type_key
	jr	nz, noesllave
	ld  e_state(iy),#e_dead
	push ix
	call man_abrir_puerta

	;;PONER ENEMIGOS OCULTOS A VIVOS
	call man_entity_getArray
	ld b, a

_loopHidden:
	ld a, e_etype(ix)
	xor	#e_type_hidden
	jr  nz, seguirloopHidden
	ld e_etype(ix), #e_type_enemy_ghost
	ld e_state(ix), #e_alive
seguirloopHidden:
	dec b
	jr  z, finloopHidden
	ld 		de,#tam_e
	add 	ix,de
	jr 		_loopHidden
finloopHidden:
	pop  ix
	jr  seguir

	;;CONTINUAR
noesllave:
	ld	e_state(ix), #e_dead

	jr 	fin2

finNivel:
	ld 	a, e_state(iy)
	xor #e_close
	jr  z, seguir
	call comprobar_colision
	dec d
	jr nz, seguir
	ld a,#1
	ld (tocarpuerta),a
	ret
	

seguir:

	dec c
	ret z

	ld 		de,#tam_e
	add 	iy,de
	jp 		loop2

fin2:
	
	ret

;;------------------------------------------------------------------------------------------------------------------------------

comprueba_collision_bala_enemy::

	ld    a, e_state(ix)
    xor    #e_alive
    jr    nz, fin3
	call man_entity_getArray_IY

loop3:


	ld 	a,e_etype(iy)
	xor #e_type_espejo
	jr nz, esenemigoloop

	call comprobar_colision
	dec  d
	jr   nz,seguir3
	ld hl, #_sp_espejo_1
	ld e_sprite_l(iy), l
	ld e_sprite_h(iy), h
	call activate_easter_egg
	jr seguir3




esenemigoloop:
	ld 	a,e_etype(iy)
	xor #e_type_enemy
	jr 	nz, seguir3
	ld	a, e_state(iy)
	xor	#e_alive
	jr	nz, seguir3

	
	call comprobar_colision
	dec d
	jr 	nz,seguir3
	ld	e_state(ix), #e_dead
	ld	e_state(iy), #e_dead
	jr 	fin3

seguir3:
	dec c
	ret z

	ld 		de,#tam_e
	add 	iy,de
	jr 		loop3

fin3:
	ret


;;------------------------------------------------------------------------------------------------------------------------------


;;------------------------------------------------------------------------------------------------------------------------------

comprobar_colision::

	ld 		d,#1

	ld  	a, e_x(ix)
	add 	e_sx(ix)
	add     #-1
	sub 	e_x(iy)
	jr		c, nocolisionan

	ld  	a, e_x(iy)
	add 	e_sx(iy)
	add     #-1
	sub 	e_x(ix)
	jr		c, nocolisionan


	ld  	a, e_y(ix)
	add 	e_sy(ix)
	add     #-1
	sub 	e_y(iy)
	jr		c, nocolisionan

	ld  	a, e_y(iy)
	add 	e_sy(iy)
	add     #-1
	sub 	e_y(ix)
	jr		c, nocolisionan

	ret

nocolisionan:
	 
	ld 		d,#0
	ret


