;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "cmp/entity.h.s"
.include "sys/input.h.s"
.include "man/man_entity.h.s"
.include "assets/assets.h.s"
.include "man/man_menu.h.s"

velocidad_bala = 2


sys_input_setBalaCreada:: 			;;PONEMOS LA VARIABLE BALA_CREADA A 0

	xor		a
	ld		(_bala_creada),a
	ret

;;------------------------------------------------------------------------------------------------------------------------------

sys_input_init::					;;INIICALIZAMOS EL INPUT Y PONEMOS A 1 LA DIRECCION DE LA BALA Y A CERO LA BALA_CREADA
	ld 	a, #1
	ld	(_dir_bala),a
	ld 	a, #0
	ld	(_bala_creada),a

	ret

;;------------------------------------------------------------------------------------------------------------------------------

sys_input_update::

	ld  	a, e_etype(ix)			;; SI LO QUE TENEMOS EN IX ES LA BALA SALTAMOS A CONTINUAR SINO PONEMOS LA VELOCIDAD DE X DE ESA ENTIDAD A 0
	xor		#e_type_bala
	jr 		nz,vxacero
	ld  	a, e_state(ix)			;; SI LA BALA ESTA VIVA SALTAMOS A CONTINUAR SINO PONEMOS LA VELOCIDAD DE X DE ESA ENTIDAD A 0
	xor		#e_alive
	jr 		z,continuar

vxacero: 
	ld 	e_vx(ix), #0
	ld  e_vxdec(ix), #0

continuar:

	call cpct_scanKeyboard_f_asm 	

	ld 	hl,#Key_Esc					;; COMPROBAMOS SI HEMOS PULSADO LA P
	call cpct_isKeyPressed_asm
	jr 	z, Esc_NotPressed

	call man_menu_pause


Esc_NotPressed:

	ld 	hl, #Key_O					;; COMPROBAMOS SI HEMOS PULSADO LA O
	call cpct_isKeyPressed_asm
	jr 	z,O_NotPressed

O_Pressed:							;; LA O HA SIDO PULSADA
	
	ld  hl, #_sp_jugador_1
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h
	ld 	e_vxdec(ix),#-127				;; PONEMOS LA VELOCIDAD DE X A -1 PARA MOVERNOS A LA IZQUIERDA
	ld 	a, #-1
	ld	(_dir_bala),a 				;; PONEMOS QUE LA DIRECCION DE LA BALA SEA -1, PARA QUE VAYA A LA IZQUIERDA

O_NotPressed:						;; LA O NO HA SIDO PULSADA
	ld 	hl,#Key_P 					;; COMPROBAMOS SI HEMOS PULSADO LA P
	call cpct_isKeyPressed_asm
	jr 	z, P_NotPressed

P_Pressed:		
	ld  hl, #_sp_jugador_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h					;; LA P HA SIDO PULSADA
	ld 	e_vxdec(ix),#127					;; PONEMOS LA VELOCIDAD DE X A 1 PARA MOVERNOS A LA DERECHA
	ld 	a, #1
	ld	(_dir_bala),a 				;; PONEMOS QUE LA DIRECCION DE LA BALA SEA 1, PARA QUE VAYA A LA DERECHA

P_NotPressed:

	ld a, e_estadoSalto(ix)			;;COMPROBAMOS QUE EL ESTADO DE SALTO ES IGUAL A 0, EN EL CASO DE NO SERLO NO ENTRAMOS A COMPROBAR LA Q PRESIONADA
	add #0
	jr nz,Q_NotPressed

	ld hl, #Key_Q					;;COMPROBAMOS SI SE HA PULSADO LA Q
	call cpct_isKeyPressed_asm
	jr z, Q_NotPressed

Q_Pressed:							;; LA Q HA SIDO PULSADA

	ld e_vy(ix),#-7
	ld e_vydec(ix),#128				;; PONEMOS LA VELOCIDAD DE Y A -16 PARA SUBIR PARA ARRIBA
	ld e_estadoSalto(ix),#1			;; PONEMOS EL ESTADO DE SALTO PARA QUE MIESTRAS ESTE SALTANDO NO COMPRUEBE S LA Q HA SIDO PRESIONADA



Q_NotPressed:						;;LA Q NO HA SIDO PRESIONADA

	ld a, (_bala_creada)			;; COMPROBAMOS SI LA VARIABLE BALA_CREADA ES IGAUL A 0, SI ES 0 PASAMOS A COMPROBAR SI SE HA PRESIONADO LA E SINO NO LO COMPROBAMOS
	add #0
	jr nz,E_NotPressed

	ld hl, #Key_Space				;; COMPROBAMOS SI LA E HA SIDO PRESIOANDA
	call cpct_isKeyPressed_asm
	jr z, E_NotPressed

E_Pressed:							;; SE HA PULSADO LA E
	call man_entity_getArray		;; OBTENEMOS EL ARRAY DE ENTIDADES PARA GUARDAR LA PRIMERA POSICION EN IX
	ld a,#1	
	ld (_bala_creada),a 			;; PONEMOS EL VALOR DE LA VARIABLE BALA_CREADA A 1, PARA INDICAR QUE HEMOS CREADO UNA BALA

	ld e, e_x(ix)					;; GUARDAMOS LA POSICION X DEL SPRITE EN E
	ld d, e_y(ix)					;; GUARDAMOS LA POSICION Y DEL SPRITE EN D

	ld bc,#tam_e 					;; OBTENEMOS TAMANO DE CADA ENTIDAD
buscar_bala:
	add 	ix,	bc 					;; SUMAMOS EL TAMANO DE LA ENTIDAD A IX PARA PASAR A A LA SIGUIENTE ENTIDAD
	ld  	a, e_etype(ix)			
	xor		#e_type_bala			;; RECOORREMOS TODAS LAS ENTIDADES HASTA ENCONTRAR LA ENTIDAD CON TIPO DEFAULT QUE SERA LA BALA 
	jr 		nz,buscar_bala

	ld e_state(ix), #e_alive	;; PONEMOS LA ENTIDAD DE LA BALA A TIPO BALA
	ld e_x(ix),e     				;; ACTUALIZAMOS EL VALOR DE X DE LA BALA A LA POSICION X DEL SPRITE
	ld e_y(ix),d 					;; ACTUALIZAMOS EL VALOR DE Y DE LA BALA A LA POSICION Y DEL SPRITE

	ld a,(_dir_bala)				;; COMPROBAMOS SI LA DIRECCION DE LA BALA ES DERECHA O IZQUIERDA, SI VALE 1 SALTAMOS A DERECHA
	dec a
	jr z, derecha

	ld a,#-velocidad_bala  			;; PONEMOS LA VELOCIDAD DE LA BALA A NEGATIVA PARA QUE SE MEUVA A LA IZQUIERDA
	
	ld e_vx(ix),a 					;; ACTUALIZAMOS LA VELOCIDAD DE X DE LA BALA
	ld  hl, #_sp_bala_1
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h	
	ld a,e_x(ix)					;; GUARDAMOS EL VALOR DE LA X DE LA BALA 
	dec a 							;; LO DECREMENTAMOS 1 ESE VALOR PARA QUE ESTE EN LA POSICION ANTERIOR
	ld e_x(ix),a
	ld a, e_y(ix) 					;; GUARDAMOS EL VALOR DE LA Y DE LA BALA 
	add a,#3						;; AUMENTAMOS ESE VALOR EN 3 PARA QUE APAREZCA A LA MITAD DEL SPRIITE
	ld e_y(ix),a


E_NotPressed: 						;; LA E NO HA SIDO PRESIONADA
	ret

derecha: 							;; LA BALA APARECE EN LA DERECHA DEL SPRITE
	ld a,#velocidad_bala            ;; GUARDAMOS LA VELOCIDAD DE LA BALA
	ld e_vx(ix),a
	ld  hl, #_sp_bala_0
	ld	e_sprite_l(ix), l
	ld	e_sprite_h(ix), h	
	ld a,e_x(ix)       				;; GUARDAMOS EL VALOR DE LA X DE LA BALA 
	;;add a,#4 						;; LO AUMENTAMOS EN 4 PARA QUE APAREZCA JUSTO A LA DERECHA DEL SPRITE
	ld e_x(ix),a
	ld a, e_y(ix) 					;; GUARDAMOS EL VALOR DE LA Y DE LA BALA 
	add a,#3						;; AUMENTAMOS ESE VALOR EN 8 PARA QUE APAREZCA A LA MITAD DEL SPRIITE
	ld e_y(ix),a

	ret

