;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "sys/physics.h.s"
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "cpct_functions.h.s"
.include "sys/input.h.s"
.include "assets/levels/packoceano0.h.s"
.include "assets/assets.h.s"

ancho_pantalla 	= 80
alto_pantalla 	= 200
tilemap = 0x3700-_packoceano0_size + 1
sumaposicion = 0

sys_physics_init::
	ret

;;------------------------------------------------------------------------------------------------------------------------------


sumarx::
    ld      a, e_vxdec(ix)
    bit     7,a
    jr      nz, esnegativo
 espositivo:
    add     e_xdec(ix)
    ld      e_xdec(ix),a
    jr      nc,nollevarseuna
    ld      a, e_x(ix)
    inc     a
    ld      e_x(ix), a
    jr      nollevarseuna 

 esnegativo:
    neg     
    ld      b,a
    ld      a, e_xdec(ix)
    sub     b
    ld      e_xdec(ix),a
    jr      nc, nollevarseuna
    ld      a, e_x(ix)
    dec     a
    ld      e_x(ix),a

 nollevarseuna:
    ld      a, e_x(ix)
    add     e_vx(ix)
    ld      e_x(ix), a
    ret


sumary::
    ld      a, e_vydec(ix)
    bit     7,a
    jr      nz, esnegativo_y
 espositivo_y:
    add     e_ydec(ix)
    ld      e_ydec(ix),a
    jr      nc,nollevarseuna_y
    ld      a, e_y(ix)
    inc     a
    ld      e_y(ix), a
    jr      nollevarseuna_y 

 esnegativo_y:
    neg     
    ld      b,a
    ld      a, e_ydec(ix)
    sub     b
    ld      e_ydec(ix),a
    jr      nc, nollevarseuna_y
    ld      a, e_y(ix)
    dec     a
    ld      e_y(ix),a

 nollevarseuna_y:
    ld      a, e_y(ix)
    add     e_vy(ix)
    ld      e_y(ix), a
    ret




sumarx_singuardar::

    ld      b,a  ;;Guardamos la posicion de x
    ld      a, e_vxdec(ix)
    bit     7,a 
    jr      nz, negativo
    add     e_xdec(ix)
    jr      nc, fin_suma
    inc     b
    jr      fin_suma

 negativo:
    neg 
    ld      c,a
    ld      a, e_xdec(ix)
    sub     c
    jr      nc, fin_suma
    dec     b

 fin_suma:

    ld a,b
    ret

sumary_singuardar::

    ld      b,a  ;;Guardamos la posicion de x
    ld      a, e_vydec(ix)
    bit     7,a 
    jr      nz, negativo_y
    add     e_ydec(ix)
    jr      nc, fin_suma_y
    inc     b
    jr      fin_suma_y

 negativo_y:
    neg 
    ld      c,a
    ld      a, e_ydec(ix)
    sub     c
    jr      nc, fin_suma_y
    dec     b

 fin_suma_y:

    ld a,b
    ret



saltodecimal::
    ld      a, e_vy(ix)
    add     #-5
    jr      z,nollevarseuna_y_salto

    ld      a, e_vydec(ix)
    add     #64
    add     #64
    ld      e_vydec(ix) , a
    jr      nc, nollevarseuna_y_salto
    ld      a, e_vy(ix)
    inc     a
    jr      nz, no_poner_cero
    ld      a,#1
 no_poner_cero:
    ld      e_vy(ix),a
 nollevarseuna_y_salto:
    ret







sys_physics_update_bala:: 				;; ACTUALIZAMOS LAS FISICAS DE UNA ENTIDAD
	
	ld 	e, e_vx(ix)
	bit 7,e
	jr	z, _baladerecha
	jr	_balaizquierda

_baladerecha:
	
	call 	sys_physics_posicion_tile_derecha_bala
	ld 		a,(hl)
	add 	#0
	jr 		nz, x_mov_invalido_b
	dec e
	jr 	nz, _baladerecha

	jr	x_mov_valido_b
_balaizquierda:
	call 	sys_physics_posicion_tile_izquierda_bala
	ld 		a,(hl)
	add 	#0
	jr 		nz, x_mov_invalido_b
	inc e
	jr 	nz, _balaizquierda

	jr	x_mov_valido_b


x_mov_valido_b:	
	ld 		a, e_x(ix)
	add 	e_vx(ix)					;; EL MOVIMIENTO ES VALIDO POR LO TANTO PODEMOS ACTUALIZAR EL VALOR DE X PARA QUE SE MUEVA LA ENTIDAD
	ld 		e_x(ix), a
	jr 		finx_b
x_mov_invalido_b:								;; EL MOVIMIENTO NO ES VALIDO POR LO QUE NO SE MOVERA LA ENTIDAD
	ld  	a, e_etype(ix)				;; SI LA ENTIDAD ES DE TIPO BALA CAMBIAMOS EL TIPO DE LA ENTIDAD
	xor		#e_type_bala
	jr 		z, poner_dead
	ld 		e_vx(ix), #0

finx_b:
	ld  	a, e_etype(ix)				;; COMPROBAMOS QUE LA ENTIDAD NO SEA DE TIPO BALA, EN EL CASO DE QUE SI LO SEA NO COMPROBAMOS LAS FISICAS DEL EJE Y
	xor		#e_type_bala
	jr 		nz, comprobar_tile_abajo
	ret

poner_dead: 						;; PONEMOS EL TIPO DE LA ENTIDAD DE LA BALA A DEAD
	ld 		e_state(ix), #e_dead
	ret


sys_physics_update_player:: 				;; ACTUALIZAMOS LAS FISICAS DE UNA ENTIDAD
	
	ld 		a, e_vx(ix)
    ld      b, e_vxdec(ix)
	add 	b
	jr		z, comprobar_tile_abajo
	bit     7,a
	jr      z, _movderecha
	call 	sys_physics_posicion_tile_izquierda
	ld 		a,(hl)
	add 	#0
	jr 		nz, x_mov_invalido
	jr		x_mov_valido
_movderecha:
	call 	sys_physics_posicion_tile_derecha
	ld 		a,(hl)
	add 	#0
	jr 		nz, x_mov_invalido

x_mov_valido:	
	call    sumarx
	jr 		comprobar_tile_abajo
x_mov_invalido:								;; EL MOVIMIENTO NO ES VALIDO POR LO QUE NO SE MOVERA LA ENTIDAD
	ld 		e_vx(ix), #0
    ld      e_vxdec(ix), #0

comprobar_tile_abajo:
	ld 		a, e_vy(ix)
	add 	#0
	jr 		nz, _movy
	
	call sys_physics_posicion_tile_abajo

	ld 		a,(hl)
	add		#0
	jr 		nz,finy

	ld 		e_estadoSalto(ix),#1
	ld 		e_vy(ix),#1
	ld 		e_vx(ix),#0
    ld      e_vxdec(ix), #0

_movy:
	ld 		a, e_estadoSalto(ix)        ;; COMPROBAMOS EL ESTADO DE SALTO, SI ESTE ES 1 ES PORQUE LA ENTIDAD ESTA SALTANDO Y PASAMOS A SALTO 
	dec 	a
	jr		z, salto
	jr 		finy
salto:
    ld e, e_vy(ix)
    ld a, e_vy(ix)
    ld b, e_vydec(ix)
    add b
    jr z,finy
    bit 7, e
    jr z, calcularpositivo
    jr   calcularnegativo

calcularpositivo:
    call sys_physics_posicion_tile_abajoSalto
    ld   a,(hl)
    add  #0
    jr   nz, y_mov_invalido

    jr y_mov_valido


calcularnegativo:
    call sys_physics_posicion_tile_arriba
    ld a,(hl)
    add #0
    jr nz, y_mov_invalido
    jr y_mov_valido
y_mov_valido:
    call sumary
    call saltodecimal
    jr finy


y_mov_invalido:
   ld   a,e_vy(ix)
   bit  7,a
   jr   z,toca_suelo
   ld e_vy(ix),#1
   ld e_vydec(ix),#0
   jr finy

toca_suelo:
  ld e_estadoSalto(ix), #0
  ld e_vy(ix),#0
  ld e_vydec(ix), #0


finy:
    ret


sys_physics_update_enemy::                 ;; ACTUALIZAMOS LAS FISICAS DE UNA ENTIDAD
    
    ld      a, e_vx(ix)
    ld      b, e_vxdec(ix)
    add     b
    jr      z, finx_en
    bit     7,a
    jr      z, _movderecha_en
    call    sys_physics_posicion_tile_izquierda
    ld      a,(hl)
    add     #0
    jr      nz, x_mov_invalido_en
    jr      x_mov_valido_en
_movderecha_en:
    call    sys_physics_posicion_tile_derecha
    ld      a,(hl)
    add     #0
    jr      nz, x_mov_invalido_en

x_mov_valido_en:   
    call    sumarx
    jr      finx_en
x_mov_invalido_en:                             ;; EL MOVIMIENTO NO ES VALIDO POR LO QUE NO SE MOVERA LA ENTIDAD
    ld      e_vx(ix), #0
    ld      e_vxdec(ix), #0

finx_en:
    ld      a, e_vy(ix)
    ld      b, e_vydec(ix)
    add     b
    jr      z, finy_en
    bit     7,a
    jr      z, _movabajo_en
    ld      e, e_vy(ix)
    call    sys_physics_posicion_tile_arriba
    ld      a,(hl)
    add     #0
    jr      nz, y_mov_invalido_en
    jr      y_mov_valido_en
_movabajo_en:
    call    sys_physics_posicion_tile_abajo
    ld      a,(hl)
    add     #0
    jr      nz, y_mov_invalido_en

y_mov_valido_en:   
    call    sumary
    jr      finy_en
y_mov_invalido_en:                             ;; EL MOVIMIENTO NO ES VALIDO POR LO QUE NO SE MOVERA LA ENTIDAD
    ld      e_vy(ix), #0
    ld      e_vydec(ix), #0

finy_en:
    ret


sys_physics_update_one_entity::

	ld  	a, e_etype(ix) 				;; SI LA ENTIDAD ES DE TIPO PLAYER O BALA PASAMOS A COMPROBAR LAS FISICAS
	xor		#e_type_player
	jr 		nz,phy_bala
	call sys_physics_update_player
phy_bala:
	ld  	a, e_etype(ix)
	xor		#e_type_bala
	jr 		nz, phy_enem
	ld  	a, e_state(ix)
	xor		#e_alive
	jr 		nz, phy_enem
	call sys_physics_update_bala
phy_enem:
    ld      a, e_etype(ix)              ;; SI LA ENTIDAD ES DE TIPO PLAYER O BALA PASAMOS A COMPROBAR LAS FISICAS
    xor     #e_type_enemy
    jr      nz,fin
    call sys_physics_update_enemy
fin:
	ret

;;------------------------------------------------------------------------------------------------------------------------------

sys_physics_update:: 				;; ACTUALIZAMOS LA FISICAS DE TODAS LAS ENTIDADES
	
	ld 		b, a

_loop:								;; RECORREMOS TODAS LAS ENTIDADES Y PARA CADA UNA LLAMAMOS A LA FUNCION sys_physics_update_one_entity

	push bc

	call sys_physics_update_one_entity

	pop bc
	

	dec b
	ret z

	ld 		de,#tam_e
	add 	ix,de
	jr 		_loop


sys_physics_posicion_tile_derecha::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN X = X + VX + SX && Y = Y
	ld a, e_x(ix)
	add e_sx(ix)
	add	e_vx(ix)
	dec a
    call sumarx_singuardar
	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld e, c 
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION X = X + SX + VX E Y = Y
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION X = X + SX + VX E Y = Y + SY
	ld c, e 		;; EN e ya tenemos los cálculos de X, entonces la metemos en c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e_sy(ix)
    dec a
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION X = X + SX + VX E Y = Y + SY
    ret 

sys_physics_posicion_tile_izquierda::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN X = X + VX && Y = Y
	ld a, e_x(ix)
	add	e_vx(ix)
    call sumarx_singuardar

	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld e, c 
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION X = X + VX E Y = Y
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION X = X + VX E Y = Y + SY
	ld c, e 		;; EN e ya tenemos los cálculos de X, entonces la metemos en c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e_sy(ix)
    dec a
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION X = X + VX E Y = Y + SY
    ret 

sys_physics_posicion_tile_abajo::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN X = X && Y = Y + SY + 1
	ld a, e_x(ix)

	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e_sy(ix)
    ;;add #-1
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld 	c, a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld 	d, a
    ld 	c, a
    ld 	b, #0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION X = X + SX E Y = Y + SY + 1
	ld a, e_x(ix)
	add e_sx(ix)
	dec a
	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld c, d 			;; EN e ya tenemos los cálculos de Y, entonces la metemos en c
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION 
    ret 

sys_physics_posicion_tile_arriba::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN
	ld a, e_x(ix)
	add e_sx(ix)
	dec a

	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e
    add #-1
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld  c, a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld d, a
    ld c, a
    ld b, #0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION
	ld a, e_x(ix)

	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld c,d
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION
    ret 


    sys_physics_posicion_tile_abajoSalto::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN X = X && Y = Y + SY + 1
	ld a, e_x(ix)

	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e_sy(ix)
    add #-1
    add e
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld 	c, a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld 	d, a
    ld 	c, a
    ld 	b, #0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION X = X + SX E Y = Y + SY + 1
	ld a, e_x(ix)
	add e_sx(ix)
	dec a
	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld c, d 			;; EN e ya tenemos los cálculos de Y, entonces la metemos en c
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION 
    ret 

    sys_physics_posicion_tile_derecha_bala::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN X = X + VX + SX && Y = Y
	ld a, e_x(ix)
	add e_sx(ix)
	;;add	e_vx(ix)
	dec a
	add e
	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld d, c 
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION X = X + SX + VX E Y = Y
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION X = X + SX + VX E Y = Y + SY
	ld c, d		;; EN d ya tenemos los cálculos de X, entonces la metemos en c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e_sy(ix)
    dec a
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION X = X + SX + VX E Y = Y + SY
    ret 

    sys_physics_posicion_tile_izquierda_bala::
	ld hl, #tilemap
						;;PRIMERA COMPROBACIÓN X = X + VX && Y = Y
	ld a, e_x(ix)
	;;add	e_vx(ix)
	add e

	ld	c, a
	srl c 				;;CARGARLO EN C Y DIVIDIR ENTRE 4
	srl c
	ld d, c 
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc
    				;;ACABA LA PRIMERA COMPROBACION X = X + VX E Y = Y
    ld	a, (hl)
    add #0
    ret nz
    				

    ld hl, #tilemap	;;EMPIEZA LA SEGUNDA COMPROBACION X = X + VX E Y = Y + SY
	ld c, d 		;; EN d ya tenemos los cálculos de X, entonces la metemos en c
	ld b,#0

    add hl,bc 			;; Calculamos la posición de memoria #tilemap + X 

    ld  a,e_y(ix)		;; Calculamos la y
    add e_sy(ix)
    dec a
    srl a
    srl a
    srl a 				;;dividir entre 8 

    sla a
    ld c,a

    sla a 				;;multiplicar por 4
    sla a

    add c

    ld c,a
    ld b,#0

    add hl,bc

    add hl,bc	
    ld	a, (hl) ;;ACABA LA SEGUNDA COMPROBACION X = X + VX E Y = Y + SY
    ret 