;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.


.include "sys/render.h.s"
.include "sys/input.h.s"
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "cpct_functions.h.s"
.include "assets/assets.h.s"
.include "assets/levels/packoceano0.h.s"
.include "assets/levels/oceano0.h.s"



inici_pantalla = 0xC000
inici_memoria = 0x3700-_packoceano0_size + 1
tilset_ptr	= inici_memoria + _packoceano0_OFF_001


;;sys_input_setEnemigosEstaticos:: 			;;PONEMOS LA VARIABLE BALA_CREADA A 0
;;
;;	xor		a
;;	ld		(_estaticos_dibujados),a
;;	ret



sys_eren_init::							;;INICIALIZAMOS EL ESTADO DE LA PANTALLA

	ld 		c,#0
	call cpct_setVideoMode_asm
	ld 		hl, #_pal_main
	ld 		de, #16
	call cpct_setPalette_asm
	cpctm_setBorder_asm HW_WHITE
	ret

;;------------------------------------------------------------------------------------------------------------------------------

sys_eren_clear::

	cpctm_clearScreen_asm #00
	ret

;;------------------------------------------------------------------------------------------------------------------------------

sys_eren_update::

	
	call sys_eren_render_entities

	ret

;;------------------------------------------------------------------------------------------------------------------------------


sys_eren_tilemap::
	
	ld de, #0x3700
	call cpct_zx7b_decrunch_s_asm

	ld bc, #0x1914
	ld de, #_g_tilemap0_W
	ld hl, #tilset_ptr
	call cpct_etm_setDrawTilemap4x8_ag_asm

	ld hl,#0xC000
	ld de,#inici_memoria
	call cpct_etm_drawTilemap4x8_ag_asm


	ret



;;---------------------------------------------------
sys_eren_render_entities::

	ld 		(_contador_entidades),a 	;;OBTENEMOS EL NUMERO DE ENTIDADES QUE TENEMOS EN EL ARRAY

_loop:

	;;ld		a, e_etype(ix)
	;;xor		#e_type_enemy_ghost
	;;jr		nz, noEstaticos
	;;ld 		a, (_estaticos_dibujados)
	;;dec 	a
	;;jr		z, continuar

;;noEstaticos:
	ld 		a, e_state(ix)				;;SI EL TIPO ES DEFAULT, NI BORRAMOS NI PINTAMOS
	xor 	#e_default		
	jr		z, continuar		

	ld 		e,e_punLast_l(ix) 			;;BORRAR POSICION ANTERIOR DE LA ENTIDAD
	ld 		d,e_punLast_h(ix)
	xor 	a
	ld 		c,e_sx(ix)
	ld 		b,e_sy(ix)
	push 	bc
	call cpct_drawSolidBox_asm


	ld 		a, e_state(ix)				;;SI EL TIPO ES DEAD, NO PINTAMOS
	xor 	#e_dead
	jr		z, poner_default


	ld 		a, e_state(ix)
	xor     #e_turnoff_laser
	jr 		z, turnoff_laser

	ld 		de, #inici_pantalla  		;;PINTAMOS EL SPRITE EN PANTALLA
	ld 		c, e_x(ix)
	ld 		b, e_y(ix)
	call cpct_getScreenPtr_asm

	ld 		e_punLast_l(ix),l 			;;GUARDAMOS LA POSICION ACTUAL DEL SPRITE PARA LUEGO BORRALO
	ld 		e_punLast_h(ix),h


	ex 		de,hl						;; LO MENTEMOS EN EL REGISTRO DE EL VALOR DE HL 
	ld 		l,e_sprite_l(ix)			;; MENTEMOS AHORA EN HL LA POSICION ACTUAL DEL SPRITE
	ld 		h,e_sprite_h(ix)
	pop bc
	call cpct_drawSprite_asm			;; PINTAMOS


continuar:
_contador_entidades = .+1
	ld 		a,#0
	dec a 								;; DECREMENTAMOS EN NUMERO DE ENTIDADES, EN EL CASO QUE SEA 0 SALIMOS DEL BUCLE
	ret z

	ld		(_contador_entidades),a 	
	ld 		bc,#tam_e					;; AVANZAMOS A LA SIGUIENTE ENTIDDAD EN EL ARRAY DE ENTIDADES
	add 	ix,bc
	jr 		_loop


poner_default:							;; SI LA BALA ES DE TIPO DEAD LA PONEMOS A DEFAULT
	ld 		e_state(ix), #e_default
	ld		a, e_etype(ix)
	xor		#e_type_bala
	jr		nz, fin
	call 	sys_input_setBalaCreada
fin:
	pop 	bc
	;;ld		a, #1
	;;ld		(_estaticos_dibujados), a
	jr		continuar


turnoff_laser:

	ld 	e_sy(ix), #8
	ld  hl,#_sp_cabezalaser_v
	ld e_sprite_l(ix),l
	ld e_sprite_h(ix),h
	ld e_etype(ix),#e_type_laser
	ld e_state(ix), #e_alive


	jr 		fin